#include <system.h>
#include <rand.h>
#include "pattern.h"
extern unsigned char led[30];
#define MAX_BRIGHT 15

void inc_led(unsigned char nLed)
{
	if (nLed<0) return;
	if (nLed>29) return;
	if (led[nLed]==15) return;
	led[nLed] = led[nLed]+1;
}

void dec_led(unsigned char nLed)
{	
	if (nLed<0) return;
	if (nLed>29) return;
	if (led[nLed]==0) return;
	led[nLed]=led[nLed]-1;
}
void set_led(unsigned char nLed, unsigned char nBright)
{
	if (nLed<0) return;
	if (nLed>29) return;
	if (nBright<0) return;
	if (nBright>MAX_BRIGHT) return;
	led[nLed]=nBright;
}
void led_glow(unsigned char nLed, unsigned char nBrightness)
{
	unsigned char k;
	if(nLed<0) return;
	if(nLed>29) return;
	
	led[nLed]=nBrightness;
	k = led[nLed];
	set_led(nLed-1,k/2);
	set_led(nLed+1,k/2);
	set_led(nLed-2,k/3);
	set_led(nLed+2,k/3);
	set_led(nLed-3,k/4);
	set_led(nLed+3,k/4);
	set_led(nLed+4,k/5);
	set_led(nLed-4,k/5);
}
void do_cylon(void)
{
	unsigned char nBrightLed;
	signed char dir;
	unsigned char i;
	unsigned int k;
	dir=1;
	nBrightLed=0;
	led[nBrightLed]=15;
	for(k=0;k<50;k++)
	{
		for(i=0;i<30;i++)
			dec_led(i);
		delay_ms(50);
		nBrightLed=nBrightLed+dir;
		if (nBrightLed==30) 
		{
			nBrightLed=29;
			dir = -dir;
		}
		if (nBrightLed>30) 
		{
			nBrightLed=0;
			dir = -dir;
		}
		led[nBrightLed]=15;
	}
}


void do_et(void)
{
	unsigned char sprite_left[3];
	unsigned char sprite_right[3];

	unsigned char i,j,k;
	unsigned char nNumSprites;
	

	nNumSprites = 3;
	for(i=0;i<nNumSprites;i++)
	{

		j = rand();
		sprite_left[i] = j % 20+10;
		sprite_right[i] = sprite_left[i];
		led[sprite_left[i]]=MAX_BRIGHT;
	}
	
	while(1)
	{
		
		//Do fade
		for(i=0;i<30;i++)
			dec_led(i);	
			
					for(i=0;i<nNumSprites;i++)
		{
			if(sprite_left[i]!=255)
			{
				if (sprite_left[i]!=0)
					sprite_left[i] = sprite_left[i]-1;
				else
				{
					sprite_left[i]=255;
					if (sprite_right[i]==255)
					{
						j = rand();
						sprite_left[i] = j % 20+10;
						sprite_right[i] = sprite_left[i];
						led[sprite_left[i]]=MAX_BRIGHT;
					};
				}
			}
			if(sprite_right[i]!=255)
			{
				if (sprite_right[i]!=29)
					sprite_right[i] = sprite_right[i]+1;
				else
				{
					sprite_right[i]=255;
					if (sprite_left[i]==255)
					{
						j = rand();
						sprite_left[i] = j % 20+10;
						sprite_right[i] = sprite_left[i];
						led[sprite_left[i]]=MAX_BRIGHT;
					};
				}
			}
			k=sprite_left[i];
			if(k!=255)
				led[k]=MAX_BRIGHT;
			k=sprite_right[i];
			if(k!=255)
				led[k]=MAX_BRIGHT;
		}	
		delay_ms(50);	
	}
}

void do_wanderingdots(void)
{
	unsigned char sprite[3];
	signed char dir[3];
	unsigned char i,j,k;
	unsigned char IsSprite;
	
	for(i=0;i<3;i++)
	{
		sprite[i]=rand()%30;
		dir[i] = rand()%2;
		if(dir[i]==0)dir[i]=-1;
	}
	
	while(1)
	{
		for(i=0;i<3;i++)
		{
			sprite[i] = sprite[i]+dir[i];
			if(led[sprite[i]]==15)
			{
				dir[i]=-dir[i];
				//sprite[i]=rand()%30;
			}
			if(sprite[i]>29)dir[i]=-dir[i];
			led_glow(sprite[i],15);
		}
	/*
			for(i=0;i<30;i++)
			{
				IsSprite = 0;
				for(j=0;j<3;j++)
					if(sprite[j]==i)IsSprite=1;
				if (IsSprite!=1)
					dec_led(i);
				
			}	
		*/
		delay_ms(80);
	}
}	

void do_random(void)
{
	unsigned char nMax[30];
	signed char nDir[30];
	unsigned char i,j;
	
	for(i=0;i<30;i++)
	{
		nMax[i]=rand()%16;
		nDir[i]=rand()%2;
		if(nDir[i]==0)nDir[i]=-1;
		led[i]=nMax[i];
	}
	while(1)
	{
		for(i=0;i<30;i++)
		{

			
			nMax[i]=nMax[i]+nDir[i];
			
			if(nMax[i]==0 && nDir[i]==-1)
			{
				nMax[i]=rand()%16;
				nDir[i]=1;
			}
			
			if(nMax[i]==30 && nDir[i]==1)
			{
				nDir[i]=-1;
			}
			led[i]=nMax[i];
		}
		delay_ms(50);
	}
}
	
	

